<template>
  <form @submit.prevent="editDocument">
    <!-- FIXME: Arrow navigation is not working due to DSFR - See https://github.com/GouvernementFR/dsfr/issues/517 -->
    <AtomInput
      label="Nom du document"
      name="filename_download"
      required
      :value="document.filename_download"
    />
    <AtomSelect
      label="Type de fichier"
      name="document_type"
      :options="DOCUMENT_TYPE_OPTIONS"
      required
      :model-value="document.document_type"
    />
    <!-- FIXME: Arrow navigation is not working due to DSFR - See https://github.com/GouvernementFR/dsfr/issues/517 -->
    <AtomSearchableSelect
      label="Thèmes"
      name="labels"
      :options="DOCUMENT_THEME_OPTIONS"
      multiple
      :value="document.labels"
    />
    <AtomCheckbox
      v-if="canSetDocumentAsConfidential"
      class="fr-mb-2w"
      label="Confidentiel"
      name="confidential"
      :model-value="document.confidential"
    />
    <button
      class="fr-btn fr-mt-3w"
      title="Modifier"
      type="submit"
      :submitting="isSubmitting"
    >
      Modifier
    </button>
  </form>
</template>

<script setup>
  import {
    checkboxValuesToBoolean,
    directusItemDiff,
    setEmptyFieldsToNull
  } from '~/utils'
  import {
    DOCUMENT_TYPE_OPTIONS,
    DOCUMENT_THEME_OPTIONS
  } from '~/utils/constants/document'
  import { errorResponseMessage } from '~/utils/errorResponse'
  import { dataObjectFromForm, formFromEvent } from '~/utils/formData'
  import { usePermissionsStore } from '~/store/permissions'

  const { $apiRequest, $snackbar, $modal } = useNuxtApp()
  const permissionsStore = usePermissionsStore()

  const props = defineProps({
    document: { type: Object, required: true }
  })

  const emit = defineEmits(['edited'])

  const isSubmitting = ref(false)

  const canSetDocumentAsConfidential = computed(() =>
    permissionsStore.canSetDocumentAsConfidential(props.document)
  )

  async function editDocument(event) {
    const CHECKBOX_KEYS = ['confidential']
    isSubmitting.value = true
    const form = formFromEvent(event)
    const documentData = checkboxValuesToBoolean(
      dataObjectFromForm(form),
      CHECKBOX_KEYS
    )
    try {
      const documentChanges = directusItemDiff(props.document, {
        ...props.document,
        ...setEmptyFieldsToNull(documentData)
      })

      if (!documentChanges) onSuccessfulEdit(props.document)
      else {
        // Directus directly treats labels as JSON
        if (documentChanges.labels) {
          documentChanges.labels = JSON.stringify(
            documentChanges.labels.split(',')
          )
        }
        const res = await $apiRequest(
          `/files/${props.document.id}`,
          {
            method: 'patch',
            data: documentChanges
          },
          {
            fields: [
              'id',
              'document_type',
              'filename_download',
              'type',
              'filesize',
              'labels',
              'confidential'
            ]
          }
        )

        if (res?.status === 200) {
          onSuccessfulEdit(res.data.data)
        } else throw new Error(errorResponseMessage(res))
      }
    } catch {
      $snackbar.error('La modification du document a échoué.')
    } finally {
      isSubmitting.value = false
    }
  }

  function onSuccessfulEdit(document) {
    emit('edited', document)
    $modal.close()
  }
</script>
